package main

import (
	"fmt"
	"net/http"

	"bitbucket.org/_metalogic_/log"

	httpSwagger "bitbucket.org/_metalogic_/httptreemux-swagger"
	_ "bitbucket.org/_metalogic_/httptreemux-swagger/example/docs" // docs is generated by Swag CLI, you have to import it.
	"github.com/dimfeld/httptreemux/v5"
)

// @title Example API
// @version 1.0
// @description This is a example API service with Swagger docs annotations.
// @termsOfService https://metalogicsoftware.ca/terms/

// @contact.name API Support
// @contact.url https://metalogicsoftware.ca/support
// @contact.email dev@metalogicsoftware.ca

// @license.name Apache 2.0
// @license.url http://www.apache.org/licenses/LICENSE-2.0.html

// @host localhost:1323
// @BasePath /example/v1
func main() {
	log.SetLevel(log.DebugLevel)

	treemux := httptreemux.New()
	api := treemux.NewGroup("/example/v1")

	api.GET("/health", Health)

	api.GET("/swagger/*", httpSwagger.Handler(
		httpSwagger.URL("doc.json"), //The url pointing to API definition
		httpSwagger.DeepLinking(true),
		httpSwagger.DocExpansion("none"),
		httpSwagger.DomID("#swagger-ui")))

	log.Fatal(http.ListenAndServe(":1323", treemux))
}

// Health returns 200 ok
// @Summary check health of example-api
// @Description checks health of example-api service
// @ID get-health
// @Produce  plain
// @Success 200 {string} string "ok"
// @Router /health [get]
func Health(w http.ResponseWriter, r *http.Request, params map[string]string) {
	w.Header().Set("Content-Type", "text/plain")
	fmt.Fprint(w, "ok\n")
}
